
; Gradius 3 FastRom V1.2
; Created By: slidelljohn
; Date: 4-15-23
; Setup for FastRom speed

lorom

org $80FFD5 ;Snes Rom Registration Data rom speed setting
{
	db $30 ;Sets to FastRom speed in Rom Registration Data but it doesnt effect FastRom speed.
	       ;Only setting 0x01 to 420D Rom Speed Register will set Rom to FastRom speed.
}

org $80FFAC ;Jump for NMI vector
{ 
    JML $808223 ;Sets Program Bank to FastRom
}

org $80FFEA ;NMI Vector setting
{
	dw $FFAC ;NMI start address
}

org $80FFFA ;NMI Vector setting
{
	dw $FFAC ;NMI start address
}

org $0082E7 ;Removes SlowRom setting
{
    nop #3                 ;$00/82E7 9C 0D 42    STZ $420D  [$01:420D]
}

org $008000 ;Reset Vector routine edited to set Rom Speed Register to FastRom
{
    SEI                                ;
    CLC                                ;
    XCE                                ;
    JML $808007                        ;Sets Program Bank to FastRom
    SEP #$20                           ;
    LDA #$01                           ;0x00 = SlowRom, 0x01 = FastRom
    STA $420D                          ;Rom Speed Register
    REP #$30                           ;
    LDX #$1DFF                         ;
    TXS                                ;
    LDA #$0000                         ;
    TCD                                ;
    SEP #$20                           ;
    LDA #$81                           ;
    PHA                                ;
    PLB                                ;
}   