
; Gradius 3 FastRom V1.2
; Created By: slidelljohn
; Date: 4-15-23
; Set all pulled banks to FastRom locations

lorom

;Sets all pulled banks to FastRom locations ($80-$ff)
macro PulledBanksToFastRom(address)  
    org <address>
        db read1(<address>)|$80
endmacro

;Pulled Banks
;%PulledBanksToFastRom($008013+1)   ;Old Bank: $00/8013 A9 01       LDA #$01   ->   New Bank: $81 (Edited in Gradius III (U) [!] FastRom V1.1(FastRom Setup).asm)
%PulledBanksToFastRom($008178+1)   ;Old Bank: $00/8178 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($008233+1)   ;Old Bank: $00/8233 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($008F5C+1)   ;Old Bank: $00/8F5C A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($009019+1)   ;Old Bank: $00/9019 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($009E86+1)   ;Old Bank: $00/9E86 A9 04       LDA #$04   ->   New Bank: $84
%PulledBanksToFastRom($009ED3+1)   ;Old Bank: $00/9ED3 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($00A768+1)   ;Old Bank: $00/A768 A9 03       LDA #$03   ->   New Bank: $83
%PulledBanksToFastRom($00A774+1)   ;Old Bank: $00/A774 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($00EA3B+1)   ;Old Bank: $00/EA3B A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($00F765+1)   ;Old Bank: $00/F765 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($00F798+1)   ;Old Bank: $00/F798 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($00F867+1)   ;Old Bank: $00/F867 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($00F967+1)   ;Old Bank: $00/F967 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($028450+1)   ;Old Bank: $02/8450 A9 06       LDA #$06   ->   New Bank: $86
%PulledBanksToFastRom($02846E+1)   ;Old Bank: $02/846E A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($028497+1)   ;Old Bank: $02/8497 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($0284A5+1)   ;Old Bank: $02/84A5 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02971B+1)   ;Old Bank: $02/971B A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($029832+1)   ;Old Bank: $02/9832 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($0298C8+1)   ;Old Bank: $02/98C8 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($029BC8+1)   ;Old Bank: $02/9BC8 A9 07       LDA #$07   ->   New Bank: $87
%PulledBanksToFastRom($029C40+1)   ;Old Bank: $02/9C40 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02A099+1)   ;Old Bank: $02/A099 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02A9EC+1)   ;Old Bank: $02/A9EC A9 0B       LDA #$0B   ->   New Bank: $8b
%PulledBanksToFastRom($02AA86+1)   ;Old Bank: $02/AA86 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02ACEE+1)   ;Old Bank: $02/ACEE A9 06       LDA #$06   ->   New Bank: $86
%PulledBanksToFastRom($02AD87+1)   ;Old Bank: $02/AD87 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02B6EF+1)   ;Old Bank: $02/B6EF A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02C5CA+1)   ;Old Bank: $02/C5CA A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02C61E+1)   ;Old Bank: $02/C61E A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02CC6D+1)   ;Old Bank: $02/CC6D A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02D285+1)   ;Old Bank: $02/D285 A9 0D       LDA #$0D   ->   New Bank: $8d
%PulledBanksToFastRom($02D3E6+1)   ;Old Bank: $02/D3E6 A9 0D       LDA #$0D   ->   New Bank: $8d
%PulledBanksToFastRom($02D454+1)   ;Old Bank: $02/D454 A9 0D       LDA #$0D   ->   New Bank: $8d
%PulledBanksToFastRom($02D595+1)   ;Old Bank: $02/D595 A9 0D       LDA #$0D   ->   New Bank: $8d
%PulledBanksToFastRom($02D5EB+1)   ;Old Bank: $02/D5EB A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02D60D+1)   ;Old Bank: $02/D60D A9 0D       LDA #$0D   ->   New Bank: $8d
%PulledBanksToFastRom($02D65B+1)   ;Old Bank: $02/D65B A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02D710+1)   ;Old Bank: $02/D710 A9 0D       LDA #$0D   ->   New Bank: $8d
%PulledBanksToFastRom($02D74B+1)   ;Old Bank: $02/D74B A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02D76B+1)   ;Old Bank: $02/D76B A9 0D       LDA #$0D   ->   New Bank: $8d
%PulledBanksToFastRom($02D7B7+1)   ;Old Bank: $02/D7B7 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02D7C6+1)   ;Old Bank: $02/D7C6 A9 0D       LDA #$0D   ->   New Bank: $8d
%PulledBanksToFastRom($02D835+1)   ;Old Bank: $02/D835 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02DE20+1)   ;Old Bank: $02/DE20 A9 06       LDA #$06   ->   New Bank: $86
%PulledBanksToFastRom($02DE3E+1)   ;Old Bank: $02/DE3E A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02DE69+1)   ;Old Bank: $02/DE69 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02DE78+1)   ;Old Bank: $02/DE78 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02E03B+1)   ;Old Bank: $02/E03B A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02EF42+1)   ;Old Bank: $02/EF42 A9 0D       LDA #$0D   ->   New Bank: $8d
%PulledBanksToFastRom($02EFEC+1)   ;Old Bank: $02/EFEC A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02F14D+1)   ;Old Bank: $02/F14D A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02F23E+1)   ;Old Bank: $02/F23E A9 0D       LDA #$0D   ->   New Bank: $8d
%PulledBanksToFastRom($02F322+1)   ;Old Bank: $02/F322 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02FBE1+1)   ;Old Bank: $02/FBE1 A9 09       LDA #$09   ->   New Bank: $89
%PulledBanksToFastRom($02FC4E+1)   ;Old Bank: $02/FC4E A9 09       LDA #$09   ->   New Bank: $89
%PulledBanksToFastRom($02FC74+1)   ;Old Bank: $02/FC74 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02FCCB+1)   ;Old Bank: $02/FCCB A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02FF64+1)   ;Old Bank: $02/FF64 A9 01       LDA #$01   ->   New Bank: $81
%PulledBanksToFastRom($02F292+1)   ;Old Bank: $02/F292 A9 01 00    LDA #$0001 ->   New Bank: $81