
; Gradius 3 FastRom V1.2
; Created By: slidelljohn
; Date: 4-15-23
; Set all MVN banks to FastRom locations

lorom

;Sets all MVN banks to FastRom locations ($80-$ff)
macro MVNToFastRom(address)  
    org <address>
    
        if read1(<address>) < $10
           db read1(<address>)|$80
        endif
        
    org <address>+1
    
        if read1(<address>+1) < $10
           db read1(<address>+1)|$80
        endif
        
endmacro

;MVN Bank 00
%MVNToFastRom($008042+1)   ;Old Bank: $00/8042 54 00 00    MVN 00 00     ->   New Bank: $80 80
%MVNToFastRom($00806E+1)   ;Old Bank: $00/806E 54 7E 7E    MVN 7E 7E     ->   New Bank: $7e 7e
%MVNToFastRom($008083+1)   ;Old Bank: $00/8083 54 7E 7E    MVN 7E 7E     ->   New Bank: $7e 7e
%MVNToFastRom($008102+1)   ;Old Bank: $00/8102 54 00 00    MVN 00 00     ->   New Bank: $80 80
%MVNToFastRom($008110+1)   ;Old Bank: $00/8110 54 00 00    MVN 00 00     ->   New Bank: $80 80
%MVNToFastRom($008B50+1)   ;Old Bank: $00/8B50 54 00 00    MVN 00 00     ->   New Bank: $80 80
%MVNToFastRom($008B69+1)   ;Old Bank: $00/8B69 54 00 00    MVN 00 00     ->   New Bank: $80 80
%MVNToFastRom($008B83+1)   ;Old Bank: $00/8B83 54 00 00    MVN 00 00     ->   New Bank: $80 80
%MVNToFastRom($008B9B+1)   ;Old Bank: $00/8B9B 54 00 00    MVN 00 00     ->   New Bank: $80 80
%MVNToFastRom($008BB3+1)   ;Old Bank: $00/8BB3 54 00 00    MVN 00 00     ->   New Bank: $80 80
%MVNToFastRom($008BCB+1)   ;Old Bank: $00/8BCB 54 00 00    MVN 00 00     ->   New Bank: $80 80
%MVNToFastRom($008BE3+1)   ;Old Bank: $00/8BE3 54 7F 7F    MVN 7F 7F     ->   New Bank: $7f 7f
%MVNToFastRom($008BFB+1)   ;Old Bank: $00/8BFB 54 00 00    MVN 00 00     ->   New Bank: $80 80
%MVNToFastRom($008C14+1)   ;Old Bank: $00/8C14 54 00 00    MVN 00 00     ->   New Bank: $80 80
%MVNToFastRom($008C2D+1)   ;Old Bank: $00/8C2D 54 7E 7E    MVN 7E 7E     ->   New Bank: $7e 7e
%MVNToFastRom($008C45+1)   ;Old Bank: $00/8C45 54 00 00    MVN 00 00     ->   New Bank: $80 80
%MVNToFastRom($008C5E+1)   ;Old Bank: $00/8C5E 54 00 00    MVN 00 00     ->   New Bank: $80 80
%MVNToFastRom($008C77+1)   ;Old Bank: $00/8C77 54 00 00    MVN 00 00     ->   New Bank: $80 80
%MVNToFastRom($008C90+1)   ;Old Bank: $00/8C90 54 00 00    MVN 00 00     ->   New Bank: $80 80
%MVNToFastRom($008CA9+1)   ;Old Bank: $00/8CA9 54 7E 7E    MVN 7E 7E     ->   New Bank: $7e 7e
%MVNToFastRom($008CC2+1)   ;Old Bank: $00/8CC2 54 7E 7E    MVN 7E 7E     ->   New Bank: $7e 7e
%MVNToFastRom($008CDA+1)   ;Old Bank: $00/8CDA 54 7E 7E    MVN 7E 7E     ->   New Bank: $7e 7e
%MVNToFastRom($009DDF+1)   ;Old Bank: $00/9DDF 54 7E 04    MVN 7E 04     ->   New Bank: $7e 84
%MVNToFastRom($00C24F+1)   ;Old Bank: $00/C24F 54 00 00    MVN 00 00     ->   New Bank: $80 80
%MVNToFastRom($00C9AE+1)   ;Old Bank: $00/C9AE 54 00 00    MVN 00 00     ->   New Bank: $80 80
%MVNToFastRom($00CAC3+1)   ;Old Bank: $00/CAC3 54 00 00    MVN 00 00     ->   New Bank: $80 80

;MVN Bank 02
%MVNToFastRom($029223+1)   ;Old Bank: $02/9223 54 7E 01    MVN 7E 01     ->   New Bank: $7e 81
%MVNToFastRom($02A381+1)   ;Old Bank: $02/A381 54 7E 01    MVN 7E 01     ->   New Bank: $7e 81
%MVNToFastRom($02AED6+1)   ;Old Bank: $02/AED6 54 7E 01    MVN 7E 01     ->   New Bank: $7e 81
%MVNToFastRom($02C30F+1)   ;Old Bank: $02/C30F 54 7E 01    MVN 7E 01     ->   New Bank: $7e 81
%MVNToFastRom($02CC18+1)   ;Old Bank: $02/CC18 54 7E 01    MVN 7E 01     ->   New Bank: $7e 81
%MVNToFastRom($02CD11+1)   ;Old Bank: $02/CD11 54 00 00    MVN 00 00     ->   New Bank: $80 80
%MVNToFastRom($02DDE5+1)   ;Old Bank: $02/DDE5 54 7E 7E    MVN 7E 7E     ->   New Bank: $7e 7e